package test.isjee.monitor.app.client.sless;

import javax.ejb.EJB;
import test.isjee.monitor.app.ejb.sless.*;
import test.isjee.monitor.app.ejb.slessex.*;
import test.isjee.monitor.app.ejb.sless2.*;
import test.isjee.monitor.app.ejb.testl.*;
import javax.naming.InitialContext;
import javax.rmi.*;
import javax.naming.* ;
import java.util.*;

public class ClientMain  extends Thread {

    public ClientMain(int no, String type, int sleepTime) {
    	thNo = no;
      this.type = type;
      this.sleepTime = sleepTime;
    }
    
    int thNo;
    String type;
    int sleepTime;
    
    public static void main(String args[]) {
        try
        {
            if(args.length < 2) {
              System.out.println("args[] Bad Parameter!");
              System.out.println("args[0]:thread, args[1]:type, [ args[2]: sleepTime ]");
              System.exit(0);
            }
            
            System.out.println("START: ClientMain");
            int count = Integer.parseInt(args[0]);
            String testname = args[1];
            int time = 5;
            
            if (args.length > 2)
              time = Integer.parseInt(args[2]);

            for (int i = 0; i < count; i++) {
              ClientMain test = new ClientMain(i,args[1], time);
              Thread th = new Thread(test);
              th.start();
            }
        }
        catch(Exception ex) {
            System.out.println("END_Exception: ClientMain");
            ex.printStackTrace();
        }
    }
    
    public void run() {
      try{
        System.out.println("*START* Thread No:"+thNo);
        InitialContext ic = new InitialContext();
        if (type.equals("SLSB3")) {
          SlessRemote hello = (SlessRemote)ic.lookup("test.isjee.monitor.app.ejb.sless.SlessRemote");
          hello.businessMethod(sleepTime);
        } else if (type.equals("SLSB3EXT")) {
          SlessExtRemote hello = (SlessExtRemote)ic.lookup("test.isjee.monitor.app.ejb.slessex.SlessExtRemote");
          hello.businessMethod(sleepTime);
        } else if (type.equals("SLSB2")) {
          Object ejbobj = (java.lang.Object)ic.lookup("test.isjee.monitor.app.ejb.sless2.Sless2BeanHome");
          Sless2BeanHome home = (Sless2BeanHome)javax.rmi.PortableRemoteObject.narrow(ejbobj, Sless2BeanHome.class);
          Sless2Remote hello = home.create();
          hello.businessMethod(sleepTime);
          hello.remove();
        } else if (type.equals("SLSB2L")) {
          TestLocalRemote hello = (TestLocalRemote)ic.lookup("test.isjee.monitor.app.ejb.testl.TestLocalRemote");
          hello.callLocalStateless(sleepTime);
        } else if (type.equals("SLSB3L")) {
          TestLocalRemote hello = (TestLocalRemote)ic.lookup("test.isjee.monitor.app.ejb.testl.TestLocalRemote");
          hello.callEJB3LocalStateless(sleepTime);
        } else {}
        System.out.println("Thread No:"+thNo+" type:"+type);
      }catch(Exception ex) {
        ex.printStackTrace();
        System.exit(0);
      }
    }
}
