package test.isjee.monitor.app.ejb.mdb;

import java.util.ArrayList;
import java.util.Iterator;
import javax.ejb.MessageDriven;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

@MessageDriven(mappedName = "jms/ObjectQueueJndiName")
@TransactionAttribute(value = TransactionAttributeType.REQUIRED)
public class HelloMDB implements MessageListener {

    public void onMessage(Message message) {
      System.out.println("[ HelloMDB#onMessage ] Start");
    
      try {
        if (message instanceof TextMessage) {   
          TextMessage txtmsg = (TextMessage) message;   
          System.out.println("[ HelloMDB#onMessage ] Got message: "+txtmsg.getText());
          if (txtmsg.getText().equals("error")) {
            System.out.println("[ HelloMDB#onMessage ] throwing RuntimeException");
            throw new RuntimeException();
          }
        } 
        System.out.println("[ HelloMDB#onMessage ] begin sleep");
        Thread.sleep(30 * 1000);
        System.out.println("[ HelloMDB#onMessage ] end sleep");
    
      } catch (JMSException jmse) {
          throw new RuntimeException(jmse);
      } catch (Exception e) {
          throw new RuntimeException(e);
      }
      
      System.out.println("[ HelloMDB#onMessage ] End");
  }
}