package test.isjee.monitor.app.ejb.mdb2;

import javax.ejb.*;
import javax.jms.*;
import javax.naming.InitialContext;

public class HelloMDB2 implements javax.ejb.MessageDrivenBean, javax.jms.MessageListener {
	
	private javax.ejb.MessageDrivenContext context;
	private javax.naming.Context initialContext = null;

	public HelloMDB2() {
		
		try
		{
			initialContext = new InitialContext();
		}
		catch(javax.naming.NamingException e)
		{
			e.printStackTrace();
			throw new javax.ejb.EJBException(e.toString());
		}
	}

	public void ejbCreate() throws javax.ejb.EJBException {
	}

	public void ejbRemove() throws javax.ejb.EJBException {
    System.out.println( "[ HelloMDB2#ejbRemove ]" ) ;
	}

	public void setMessageDrivenContext(javax.ejb.MessageDrivenContext ctx) throws javax.ejb.EJBException {

		context = ctx;
	}

	public void onMessage(javax.jms.Message msg) {

		System.out.println( "[ HelloMDB2#onMessage ] Start" ) ;
		javax.jms.TextMessage text = (TextMessage)msg ;
		try {
			System.out.println( "[ HelloMDB2#onMessage ] Got message: " + text.getText() ) ;
      if (text.getText().equals("error")) {
        System.out.println("[ HelloMDB2#onMessage ] throwing RuntimeException");
        throw new RuntimeException();
      }
      
      System.out.println("[ HelloMDB2#onMessage ] begin sleep");
      Thread.sleep(30 * 1000);
      System.out.println("[ HelloMDB2#onMessage ] end sleep");
      
		} catch( Exception e ) {
			throw new RuntimeException(e);
		}
		System.out.println( "[ HelloMDB#onMessage ] End" ) ;
	}
}
