package test.isjee.monitor.app.ejb.sless2;

import java.rmi.*;

import java.util.*;

import javax.ejb.*;

public class Sless2Bean extends Object implements SessionBean {
    //
    static final boolean verbose = true;
    
    private transient SessionContext ctx;
    
    // Implement the methods in the SessionBean
    // interface
    public void ejbActivate() throws EJBException, RemoteException {
        if(verbose) {
            System.out.println("ejbActivate called");
        }
    }
    
    public void ejbRemove() throws EJBException, RemoteException {
        if(verbose) {
            System.out.println("ejbRemove called");
        }
    }
    
    public void ejbPassivate() throws EJBException, RemoteException {
        if(verbose) {
            System.out.println("ejbPassivate called");
        }
    }
    
    /**
     * Sets the session context.
     *
     * @param SessionContext
     */
    public void setSessionContext(SessionContext ctx) throws EJBException, RemoteException {    
        if(verbose) {
            System.out.println("setSessionContext called");
        }
        this.ctx = ctx;
    }
    
    /**
     * This method corresponds to the create method in
     * the home interface Sless2BeanHome.java.
     *
     * The parameter sets of the two methods are
     * identical. When the client calls
     * Sless2BeanHome.create(), the container allocates an
     * instance of the EJBean and calls ejbCreate().
     */
    public void ejbCreate() throws CreateException {
        if(verbose) {
            System.out.println("ejbCreate called");
        }
    }
    
    /**
     * **** HERE IS THE BUSINESS LOGIC *****
     * Do the businessMethod() but don't even go to
     * the database in this eg but instead just
     * return a String.
     */
    public void businessMethod(int sleepTime) throws RemoteException {
        try {
            System.out.println("begin sleep in stateless");
            Thread.sleep(sleepTime * 1000);
            System.out.println("end sleep in stateless");
        } catch(Exception e) {
            //
        }
    }
}
