package test.isjee.monitor.app.ejb.testl;

import java.util.*;
import test.isjee.monitor.app.ejb.slessloc.*;
import test.isjee.monitor.app.ejb.sless2l.*;
import test.isjee.monitor.app.ejb.sful2l.*;
import test.isjee.monitor.app.ejb.sfulloc.*;
import javax.naming.InitialContext;
import javax.ejb.*;

@Stateless
public class TestLocalBean implements TestLocalRemote {
  
    @EJB
    public SlessLocal slesslocal;

    @EJB
    public SL2LBeanLocalHome sless2home;

    @EJB
    public SF2LBeanLocalHome sful2home;
  
    @EJB public SfulLocal sfulloc1;
    @EJB public SfulLocal sfulloc2;
    @EJB public SfulLocal sfulloc3;
    @EJB public SfulLocal sfulloc4;
    @EJB public SfulLocal sfulloc5;
    @EJB public SfulLocal sfulloc6;
    @EJB public SfulLocal sfulloc7;
    @EJB public SfulLocal sfulloc8;
    @EJB public SfulLocal sfulloc9;
    @EJB public SfulLocal sfulloc10;

    public void callLocalStateless(int sleepTime) {
      try {
        InitialContext ic = new InitialContext();
        SL2LLocal sless = sless2home.create();
        sless.businessMethod(sleepTime);
        sless.remove();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }

    public void callEJB3LocalStateless(int sleepTime) {
      System.out.println("[TestLocalBean] callEJB3LocalStateless");
      try {
        slesslocal.businessMethod(sleepTime);
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
    
    public void callLocalStateful(int sleepTime) {
      try {
        InitialContext ic = new InitialContext();
        SF2LLocal sful = sful2home.create();
        sful.businessMethod();
        sful.remove();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
    
    public void runLocalStatefulTest(int sleepTime){   
         SF2LLocal[] local=new SF2LLocal[10];
      /*
         *Due to performance reasons, beans are not immediately 
         passivated after they are identified as candidates for passivation.
         The container performs passivations in batches 
         (that is after it accumulates some number of beans - which is set to 8 internally)
         *This is the reason why you do not see a passivation. 
         If you had created more than 8 sessions then you would see the expected behaviour. 
         *hence number 10 is chosen.
         *
         **/
        try {
            for(int i=0;i<10;i++){
               local[i]=sful2home.create();
            }
            System.out.println("Now going to sleep for "+sleepTime+" secs to passivate beans");
            Thread.sleep(sleepTime * 1000);
        }catch(javax.ejb.CreateException e){
            System.out.println("Error while creating beans");
            e.printStackTrace();
        }catch(java.lang.InterruptedException e){
            System.out.println("Error while sleeping");
            e.printStackTrace();
        }catch(Throwable e){
            System.out.println("Something unexpected happened,check logs");
            e.printStackTrace();
        }
        try{             
          for(int i=0;i<10;i++){
            local[i].businessMethod();
          }
        
         }catch(Throwable e){
             e.printStackTrace();
         }

        try {
            System.out.println("Now going to sleep for "+sleepTime+" secs to passivate beans again");
            Thread.sleep(sleepTime * 1000);
        }catch(java.lang.InterruptedException e){
            System.out.println("Error while sleeping");
            e.printStackTrace();
        }catch(Throwable e){
            System.out.println("Something unexpected happened,check logs");
            e.printStackTrace();
        }

        try{
            // Test run is over,remove all SFSB after this(productization of test,returns server to clean state
            //close all resources in SFSB remove methods
            for(int i=0;i<10;i++){
                try{
                    local[i].remove();
                    
                }catch(javax.ejb.RemoveException e){
                    System.out.println("Error while removing  :"+i+"SFSB");
                    if(i==5)
                        System.out.println("Bean 5 throws RemoveException");
                }catch(Exception e){
                    System.out.println("Error while removing  :"+i+"SFSB");
                    e.printStackTrace();
                }
            }
        }catch(Throwable e){
            e.printStackTrace();
        }
    }

    public void runEJB3LocalStatefulTest(int sleepTime){   
         //~ SF2LLocal[] local=new SF2LLocal[10];
      /*
         *Due to performance reasons, beans are not immediately 
         passivated after they are identified as candidates for passivation.
         The container performs passivations in batches 
         (that is after it accumulates some number of beans - which is set to 8 internally)
         *This is the reason why you do not see a passivation. 
         If you had created more than 8 sessions then you would see the expected behaviour. 
         *hence number 10 is chosen.
         *
         **/
        try {
            //~ for(int i=0;i<10;i++){
               //~ local[i]=sful2home.create();
            //~ }
            System.out.println("Now going to sleep for "+sleepTime+" secs to passivate beans");
            Thread.sleep(sleepTime * 1000);
        //~ }catch(javax.ejb.CreateException e){
            //~ System.out.println("Error while creating beans");
            //~ e.printStackTrace();
        //~ }catch(java.lang.InterruptedException e){
            //~ System.out.println("Error while sleeping");
            //~ e.printStackTrace();
        }catch(Throwable e){
            System.out.println("Something unexpected happened,check logs");
            e.printStackTrace();
        }
        try{             
          //~ for(int i=0;i<10;i++){
            //~ local[i].businessMethod();
          //~ }
            sfulloc1.businessMethod();
            sfulloc2.businessMethod();
            sfulloc3.businessMethod();
            sfulloc4.businessMethod();
            sfulloc5.businessMethod();
            sfulloc6.businessMethod();
            sfulloc7.businessMethod();
            sfulloc8.businessMethod();
            sfulloc9.businessMethod();
            sfulloc10.businessMethod();
          
         }catch(Throwable e){
             e.printStackTrace();
         }

        try {
            System.out.println("Now going to sleep for "+sleepTime+" secs to passivate beans again");
            Thread.sleep(sleepTime * 1000);
        }catch(java.lang.InterruptedException e){
            System.out.println("Error while sleeping");
            e.printStackTrace();
        }catch(Throwable e){
            System.out.println("Something unexpected happened,check logs");
            e.printStackTrace();
        }

        try{
            // Test run is over,remove all SFSB after this(productization of test,returns server to clean state
            //close all resources in SFSB remove methods
            //~ for(int i=0;i<10;i++){
                //~ try{
                    //~ local[i].remove();
                //~ }catch(javax.ejb.RemoveException e){
                    //~ System.out.println("Error while removing  :"+i+"SFSB");
                    //~ if(i==5)
                        //~ System.out.println("Bean 5 throws RemoveException");
                //~ }catch(Exception e){
                    //~ System.out.println("Error while removing  :"+i+"SFSB");
                    //~ e.printStackTrace();
                //~ }
            //~ }
               sfulloc1.removeMethod();
              sfulloc2.removeMethod();
              sfulloc3.removeMethod();
              sfulloc4.removeMethod();
              sfulloc5.removeMethod();
              sfulloc6.removeMethod();
              sfulloc7.removeMethod();
              sfulloc8.removeMethod();
              sfulloc9.removeMethod();
              sfulloc10.removeMethod();
        }catch(Throwable e){
            e.printStackTrace();
        }
    }

}
